// Code128DemoView.cpp : implementation of the CCode128DemoView class
//

#include "stdafx.h"
#include "Code128Demo.h"

#include "Code128DemoDoc.h"
#include "Code128DemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "MW6FontEncoder.lib")
extern "C" __declspec(dllimport) WORD _stdcall MW6Encode(WORD BarcodeType, 
														 LPCTSTR SourceText, 
														 WORD ApplyTilde, 
														 LPTSTR lpFormattedTextBuffer,
														 WORD FTBSize,
														 LPTSTR lpHumanReadableTextBuffer,
														 WORD HRTBSize);

/////////////////////////////////////////////////////////////////////////////
// CCode128DemoView

IMPLEMENT_DYNCREATE(CCode128DemoView, CView)

BEGIN_MESSAGE_MAP(CCode128DemoView, CView)
	//{{AFX_MSG_MAP(CCode128DemoView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCode128DemoView construction/destruction

CCode128DemoView::CCode128DemoView()
{
	// TODO: add construction code here

}

CCode128DemoView::~CCode128DemoView()
{
}

BOOL CCode128DemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCode128DemoView drawing

void CCode128DemoView::OnDraw(CDC* pDC)
{
	CCode128DemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	// Create Code128 font
	LOGFONT barcodeFont;
	memset(&barcodeFont, 0, sizeof(LOGFONT));
	barcodeFont.lfHeight = -40;
	strcpy(barcodeFont.lfFaceName, "MW6 Code128S");
	CFont bFont;
	VERIFY(bFont.CreateFontIndirect(&barcodeFont));

	LOGFONT textFont;
	memset(&textFont, 0, sizeof(LOGFONT));
	textFont.lfHeight = 15;
	strcpy(barcodeFont.lfFaceName, "Arial");
	CFont tFont;
	VERIFY(tFont.CreateFontIndirect(&textFont));

	CRect rect;
	GetClientRect(&rect);
	
	char formattedText[4096];
	char hrText[4096];
	pDC->SetTextAlign(TA_BASELINE | TA_CENTER);
	pDC->SetTextColor(RGB(0, 0, 0));

	if (MW6Encode(100, "1234567890", 0, formattedText, 4096, hrText, 4096) != 0)
	{
		// Code 128 Auto
		pDC->SelectObject(&bFont);
		pDC->TextOut(200, 100, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(200, 100 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}
	else
	{
		// Something is wrong with Encoder library.
		// One more error is that the buffer size of 
		// formatted text or human readable text is too small.
	}


	if (MW6Encode(101, "ABCD789~d048", 1, formattedText, 4096, hrText, 4096) != 0)
	{
		// Code 128 A, use ~dNNN to represent a character with ASCII value NNN
		pDC->SelectObject(&bFont);
		pDC->TextOut(200, 200, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(200, 200 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}

	if (MW6Encode(102, "EFGH3456789~d049", 1, formattedText, 4096, hrText, 4096) != 0)
	{
		// Code 128 B, use ~dNNN to represent a character with ASCII value NNN
		pDC->SelectObject(&bFont);
		pDC->TextOut(200, 300, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(200, 300 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}

	if (MW6Encode(103, "9876543210", 0, formattedText, 4096, hrText, 4096) != 0)
	{
		// Code 128 C
		pDC->SelectObject(&bFont);
		pDC->TextOut(200, 400, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(200, 400 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}

	if (MW6Encode(104, "98765123456789", 0, formattedText, 4096, hrText, 4096) != 0)
	{
		// UCC/EAN 128
		pDC->SelectObject(&bFont);
		pDC->TextOut(700, 100, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(700, 100 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}

	if (MW6Encode(105, "(01)12345678901234(3103)123456", 0, formattedText, 4096, hrText, 4096) != 0)
	{
		// GS1 128
		pDC->SelectObject(&bFont);
		pDC->TextOut(700, 200, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(700, 200 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}

	if (MW6Encode(106, "123456789012~d051", 1, formattedText, 4096, hrText, 4096) != 0)
	{
		// SCC-14, use ~dNNN to represent a character with ASCII value NNN
		pDC->SelectObject(&bFont);
		pDC->TextOut(700, 300, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(700, 300 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}

	if (MW6Encode(107, "~d0481234567891234567", 1, formattedText, 4096, hrText, 4096) != 0)
	{
		// SSCC-18, use ~dNNN to represent a character with ASCII value NNN
		pDC->SelectObject(&bFont);
		pDC->TextOut(700, 400, formattedText, strlen(formattedText));

		pDC->SelectObject(&tFont);
		pDC->TextOut(700, 400 - barcodeFont.lfHeight/3, hrText, strlen(hrText));
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCode128DemoView printing

BOOL CCode128DemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCode128DemoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCode128DemoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CCode128DemoView diagnostics

#ifdef _DEBUG
void CCode128DemoView::AssertValid() const
{
	CView::AssertValid();
}

void CCode128DemoView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCode128DemoDoc* CCode128DemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCode128DemoDoc)));
	return (CCode128DemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCode128DemoView message handlers
